/**
 * @module      editor_marklar/editor
 * @copyright   2016 David Mudrak <david@moodle.com>
 * @license     http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
 */
define("editor_marklar/editor",["jquery","core/yui","core/str","core/log","core/ajax","core/event","editor_marklar/filepicker","editor_marklar/imagepaster"],(function($,Y,str,log,ajax,event,filepicker,ImagePaster){function MarklarEditor(textarea,initparams){this.initparams=initparams,void 0!==M.editor_marklar.fpoptions[initparams.elementid]&&(this.initparams.filepickeroptions=M.editor_marklar.fpoptions[initparams.elementid]),this.initTextArea(textarea),this.initFormatSelector(),this.initPanel(),this.initFilesEmbedding(),this.initPreview(),this.initSyntaxHelp(),this.initImagePaster()}return MarklarEditor.prototype.initTextArea=function(textarea){this.textarea=textarea.addClass("marklar-textarea").css("box-sizing","border-box").css("width","100%").css("background-color","white").css("margin-bottom","10px").css("padding","7px"),this.initparams.monospace&&this.textarea.css("font-family","monospace")},MarklarEditor.prototype.initFormatSelector=function(){var self=this,fname=self.textarea.attr("name").replace("[text]","[format]"),form=self.textarea.closest("form");if(fname!==self.textarea.attr("name")&&(self.formatSelector=form.find('select[name="'+fname+'"]'),!self.formatSelector.length)){var formatId,formatName,formatHidden=form.find('input[name="'+fname+'"]');if(formatHidden.length){switch(formatId=parseInt(formatHidden.attr("value"))){case 0:formatName="formattext";break;case 1:formatName="formathtml";break;case 2:formatName="formatplain";break;case 4:formatName="formatmarkdown";break;default:return log.error("marklar: unknown text format "+formatId),void(self.formatSelector=null)}self.formatSelector=$('<select class="custom-select" name="'+fname+'"></select>').append($('<option value="'+formatId+'">'+formatName+"</option>")),formatHidden.remove(),str.get_string(formatName,"core_moodle").done((function(formatTitle){self.formatSelector.find('option[value="'+formatId+'"]').text(formatTitle)})).fail((function(ex){log.error(ex)}))}else log.error("marklar: format field not found: "+fname)}},MarklarEditor.prototype.initPanel=function(){this.textarea.wrap('<div class="marklar-wrapper"></div>'),this.panel=$('<div class="marklar-panel"></div>').insertAfter(this.textarea),this.editpanel=$('<div class="marklar-edit-panel"></div>').appendTo(this.panel),this.formatSelector&&(this.editpanel.append(this.formatSelector),this.formatSelector.attr("data-marklar-widget","format-select")),this.panel.prepend('<span data-marklar-placeholder="preview" />'),this.editpanel.append('<span data-marklar-placeholder="syntax" />'),this.editpanel.append('<span data-marklar-placeholder="insert-image" />'),this.editpanel.append('<span data-marklar-placeholder="insert-file" />')},MarklarEditor.prototype.initFilesEmbedding=function(){if("filepickeroptions"in this.initparams){var self=this;Y.use("core_filepicker",(function(){self.filepicker=filepicker.init(self.initparams.filepickeroptions),self.filepicker.canShowFilepicker("image")&&str.get_string("insertimage","editor_marklar").done((function(strinsertimage){var button=$('<button class="btn btn-default" data-marklar-widget="insert-image" />');button.text(strinsertimage),button.click((function(e){e.preventDefault(),self.filepicker.showFilepicker("image",(function(data){self.imageEmbedded(data)}))})),self.panel.find('[data-marklar-placeholder="insert-image"]').replaceWith(button),self.insertImageButton=button})),self.filepicker.canShowFilepicker("link")&&str.get_string("insertlink","editor_marklar").done((function(strinsertlink){var button=$('<button class="btn btn-default" data-marklar-widget="insert-file" />');button.text(strinsertlink),button.click((function(e){e.preventDefault(),self.filepicker.showFilepicker("link",(function(data){self.insertLink(data)}))})),self.panel.find('[data-marklar-placeholder="insert-file"]').replaceWith(button),self.insertFileButton=button}))}))}else log.error(this.initparams.elementid+": File picker options not found")},MarklarEditor.prototype.initPreview=function(){var self=this;return!!self.formatSelector&&(self.previewBody=$('<div class="marklar-preview" />').hide(),self.panel.before(self.previewBody),str.get_strings([{key:"previewon",component:"editor_marklar"},{key:"previewoff",component:"editor_marklar"}]).then((function(strings){self.previewButtonOn=$('<button class="btn btn-default" data-marklar-widget="preview-on" />').text(strings[0]).on("click",self.previewOn.bind(self)),self.previewButtonOff=$('<button class="btn btn-default" data-marklar-widget="preview-off" >').text(strings[1]).on("click",self.previewOff.bind(self)).hide();var buttonPreview=$('<div class="marklar-preview-controls" />').append(self.previewButtonOn).append(self.previewButtonOff);return self.panel.find('[data-marklar-placeholder="preview"]').replaceWith(buttonPreview),!0})))},MarklarEditor.prototype.previewOn=function(e){var self=this;return e.preventDefault(),str.get_string("previewloading","editor_marklar").then((function(strpreviewloading){return self.previewButtonOn.hide(),self.previewButtonOff.show(),self.editpanel.hide(),self.previewBody.html('<div class="marklar-preview-loading">'+strpreviewloading+"</div>"),self.previewBody.height(self.textarea.height()),self.textarea.hide(),self.previewBody.show(),self.previewLoad(),!0}))},MarklarEditor.prototype.previewOff=function(e){e.preventDefault(),this.previewButtonOff.hide(),this.previewButtonOn.show(),this.editpanel.show(),this.previewBody.hide(),this.previewBody.html(""),this.textarea.show()},MarklarEditor.prototype.previewLoad=function(){var self=this,args={text:self.textarea.val(),format:self.formatSelector.val(),contextid:self.initparams.contextid};return ajax.call([{methodname:"editor_marklar_get_preview",args:args}])[0].fail((function(err){return self.previewBody.html('<div class="alert alert-error"><b>Error:</b> '+err.message+"</div>"),log.error(err),!1})).then((function(response){return self.previewBody.html(response.html),event.notifyFilterContentUpdated(self.previewBody),!0}))},MarklarEditor.prototype.imageEmbedded=function(data){"url"in data&&this.insertText('<img alt="" class="img-responsive" src="'+data.url+'"/>')},MarklarEditor.prototype.insertLink=function(data){var texttoshow;"url"in data&&(texttoshow="file"in data&&data.file?data.file.replace(/(\[|\])/g,"_"):"texttoshow",this.insertText("["+texttoshow+"]("+data.url+")"))},MarklarEditor.prototype.insertText=function(inserttext){var areatext=this.textarea.val(),selectionStart=this.textarea.prop("selectionStart"),selectionEnd=this.textarea.prop("selectionEnd");this.textarea.val(areatext.substring(0,selectionStart)+inserttext+areatext.substring(selectionEnd))},MarklarEditor.prototype.initSyntaxHelp=function(){var self=this;return!!self.formatSelector&&(self.syntaxBody=$('<div class="marklar-syntax-help" />').hide(),self.editpanel.append(self.syntaxBody),str.get_strings([{key:"syntaxon",component:"editor_marklar"},{key:"syntaxoff",component:"editor_marklar"}]).then((function(strings){self.syntaxButtonOn=$('<button class="btn btn-link" data-marklar-widget="syntax-on" />').text(strings[0]).on("click",self.syntaxOn.bind(self)),self.syntaxButtonOff=$('<button class="btn btn-link" data-marklar-widget="syntax-off" />').text(strings[1]).on("click",self.syntaxOff.bind(self)).hide();var buttonSyntax=$('<div class="marklar-syntax-controls" />').append(self.syntaxButtonOn).append(self.syntaxButtonOff);return self.panel.find('[data-marklar-placeholder="syntax"]').replaceWith(buttonSyntax),!0})).catch((function(err){return log.error(err),!1})),self.formatSelector&&self.formatSelector.on("change",(function(){self.syntaxBody.is(":visible")&&self.syntaxButtonOn.click()})),!0)},MarklarEditor.prototype.initImagePaster=function(){this.initparams.filepickeroptions.image&&ImagePaster.init(this.textarea,this.initparams.filepickeroptions.image,this.imageEmbedded.bind(this))},MarklarEditor.prototype.syntaxOn=function(e){var self=this;return e.preventDefault(),str.get_string("syntaxloading","editor_marklar").then((function(strsyntaxloading){return self.syntaxButtonOn.hide(),self.syntaxButtonOff.show(),self.syntaxBody.html('<div class="marklar-syntax-loading">'+strsyntaxloading+"</div>"),self.syntaxBody.show(),self.syntaxLoad(),!0}))},MarklarEditor.prototype.syntaxOff=function(e){e.preventDefault(),this.syntaxButtonOff.hide(),this.syntaxButtonOn.show(),this.syntaxBody.hide(),this.syntaxBody.html("")},MarklarEditor.prototype.syntaxLoad=function(){var self=this;return str.get_string("syntax-format"+self.formatSelector.val(),"editor_marklar").then((function(strsyntax){self.syntaxBody.html(strsyntax)}))},{init:function(params){var textarea;if(!("elementid"in params))throw new Error("editor_marklar: Invalid editor init parameter - missing elementid");if((textarea=$(document.getElementById(params.elementid))).length)return new MarklarEditor(textarea,params);throw new Error("Unable to find textarea element",params.elementid)}}}));

//# sourceMappingURL=editor.min.js.map